#include <stdio.h>
#include <stdlib.h>

#include "my_app.h"
#include "plugins.h"

int a;
int b;
Plugin *P;

void hello ()
{
  printf ("Hello World!\n");
}

int main ()
{
  char choice;
  char buf[BUFLEN];
  char *plugin_name=NULL;
  Plugin *p=NULL;

  do
  {
    printf ("\n   ---  Menu items ---\n");
    printf ("   '1' .. select plugin\n");
    printf ("   '2' .. load plugin\n");
    printf ("   '3' .. execute plugin function\n");
    printf ("   '4' .. unload plugin\n");
    printf ("   'x' .. exit\n");
    printf ("\n   Your choice: ");

    fgets (buf, sizeof(buf), stdin);
    putchar ('\n');
    choice = buf[0];
    switch (choice)
    {
      case '1':
        plugin_name = plugin_select ();
        break; 
      case '2':
        if (plugin_name)
        {
          p = plugin_load (plugin_name);
          if (p)
            printf ("Plugin '%s' loaded successfully\n", plugin_name);
          P = p;
        } else
          printf ("No plugin selected\n");		
        break; 
      case '3':
        if (p)
        {
          printf ("Enter the 1st number: ");
          fgets (buf, sizeof(buf), stdin);
          a = atoi (buf);
          printf ("Enter the 2nd number: ");
          fgets (buf, sizeof(buf), stdin);
          b = atoi (buf);
          printf ("\nExecuting the plugin '%s' ...\n", plugin_name);
          plugin_action (p);
        } else
          printf ("No plugin loaded\n");
        break; 
      case '4':
        if (p)
        {
          plugin_destroy (p);
          p = NULL;
          P = NULL;
        } else
          printf ("No plugin loaded\n");
        break; 
    }
  } while (choice != 'x');

  return 0;
}
